Index: main/plugin-syndication/src/org/ametys/plugins/syndication/FeedGenerator.java
===================================================================
--- main/plugin-syndication/src/org/ametys/plugins/syndication/FeedGenerator.java	(revision 28681)
+++ main/plugin-syndication/src/org/ametys/plugins/syndication/FeedGenerator.java	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2010 Anyware Services
+ *  Copyright 2015 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -21,19 +21,26 @@
 import java.text.SimpleDateFormat;
 import java.util.ArrayList;
 import java.util.Date;
+import java.util.HashMap;
 import java.util.Iterator;
 import java.util.List;
+import java.util.Map;
 
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
 import org.apache.cocoon.ProcessingException;
 import org.apache.cocoon.environment.ObjectModelHelper;
 import org.apache.cocoon.environment.Request;
-import org.apache.cocoon.generation.AbstractGenerator;
+import org.apache.cocoon.generation.ServiceableGenerator;
 import org.apache.cocoon.xml.AttributesImpl;
 import org.apache.cocoon.xml.XMLUtils;
+import org.apache.commons.lang.StringUtils;
 import org.xml.sax.SAXException;
 
 import org.ametys.runtime.config.Config;
 import org.ametys.runtime.util.I18nizableText;
+import org.ametys.web.renderingcontext.RenderingContext;
+import org.ametys.web.renderingcontext.RenderingContextHandler;
 import org.ametys.web.repository.page.Page;
 import org.ametys.web.repository.page.ZoneItemException;
 import org.ametys.web.repository.site.Site;
@@ -60,51 +67,91 @@
  * Generates the contents of an external RSS of Atom feed.<br>
  * This implementation is based on the ROME API.
  */
-public class FeedGenerator extends AbstractGenerator
+public class FeedGenerator extends ServiceableGenerator
 {
+    /** The feed cache */
+    protected FeedCache _feedCache;
+    
+    /** The rendering context handler. */
+    protected RenderingContextHandler _renderingContext;
+    
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        super.service(serviceManager);
+        _feedCache = (FeedCache) serviceManager.lookup(FeedCache.ROLE);
+        _renderingContext = (RenderingContextHandler) serviceManager.lookup(RenderingContextHandler.ROLE);
+    }
     
     @Override
     public void generate() throws IOException, SAXException, ProcessingException
     {
-        // Check if feed url is not the page itself
-        if (_checkForInfiniteLoop(source))
-        {
-            throw new ZoneItemException("Infinite loop detected for RSS feed : " + source + ". The RSS feed url can not be the page itself.");
-        }
-        
-        URL feedSource = new URL(source);
-        HttpURLConnection connection = (HttpURLConnection) feedSource.openConnection();
-        connection.setRequestProperty("User-Agent", "Ametys/3 (compatible; MSIE 6.0)");
-        
-        int length = parameters.getParameterAsInteger("length", -1);
-        
-        SyndFeedInput input = new SyndFeedInput();
-        SyndFeed feed = null;
+        Map<String, Object> serviceParameters = (Map<String, Object>) objectModel.get(ObjectModelHelper.PARENT_CONTEXT);
+        String url = (String) serviceParameters.get("url");
+        String name = (String) serviceParameters.get("name");
+        int lifeTime = (Integer) serviceParameters.get("cache");
+        long length = (Long) serviceParameters.get("length");
+        Boolean isCustom = (Boolean) serviceParameters.get("isCustom");
+        Boolean isCheck = (Boolean) serviceParameters.get("isCheck");
         
-        try
+        contentHandler.startDocument();
+
+        if (_checkForInfiniteLoop(url))
         {
-            int responseCode = connection.getResponseCode();
-            if (responseCode != HttpURLConnection.HTTP_OK)
+            getLogger().error("Infinite loop detected for RSS feed : " + url + ". The RSS feed url can not be the page itself.");
+            if (isCustom && _renderingContext.getRenderingContext() == RenderingContext.FRONT)
             {
-                throw new ZoneItemException("Unable to join the RSS feed : " + source + ". HTTP response code is " + responseCode + ".");
+                _saxErrorFeed("feed-error-custom", url, name, null);
             }
-
-            feed = input.build(new XmlReader(connection));
+            else if (_renderingContext.getRenderingContext() == RenderingContext.BACK)
+            {
+                _saxErrorFeed("feed-error", url, name, "Infinite loop detected for RSS feed : " + url + ". The RSS feed url can not be the page itself.");
+            }
         }
-        catch (FeedException e)
+        else
         {
-            throw new ZoneItemException("Unable to read the RSS feed : " + source, e);
+            FeedResult feedResult = _feedCache.getFeed(url, lifeTime);
+            
+            if (feedResult.getStatus() == FeedResult.STATUS_OK)
+            {
+                SyndFeed feed = feedResult.getSynFeed();
+                _saxFeeds(feed, length, url, isCustom, isCheck);
+            }
+            else if (_renderingContext.getRenderingContext() == RenderingContext.BACK)
+            {
+                _saxErrorFeed("feed-error", url, name, feedResult.getMessageError());
+            }
+            else if (isCustom && _renderingContext.getRenderingContext() == RenderingContext.FRONT)
+            {
+                _saxErrorFeed("feed-error-custom", url, name, null);
+            }
         }
-        catch (IOException e)
+
+        contentHandler.endDocument();
+    }
+    
+    private void _saxErrorFeed (String errorName, String url, String name, String messageError) throws SAXException
+    {
+        AttributesImpl atts = new AttributesImpl();
+        _addAttribute(atts, "url", url);
+        _addAttribute(atts, "name", name);
+        if (StringUtils.isNotEmpty(messageError))
         {
-            throw new ZoneItemException("Unable to read the RSS feed to the url : " + source, e);
+            _addAttribute(atts, "messageError", messageError);
         }
-        
-        contentHandler.startDocument();
+
+        XMLUtils.createElement(contentHandler, errorName, atts);
+    }
+    
+    private void _saxFeeds (SyndFeed feed, long length, String url, Boolean isCustom, Boolean isCheck) throws SAXException
+    {
         AttributesImpl atts = new AttributesImpl();
 
         _addAttribute(atts, "title", feed.getTitle());
         _addAttribute(atts, "description", feed.getDescription());
+        _addAttribute(atts, "feedUrl", url);
+        _addAttribute(atts, "isCustom", String.valueOf(isCustom));
+        _addAttribute(atts, "isCheck", String.valueOf(isCheck));
 
         XMLUtils.startElement(contentHandler, "feed", atts);
         
@@ -174,7 +221,6 @@
         }
         
         XMLUtils.endElement(contentHandler, "feed");
-        contentHandler.endDocument();
     }
     
     private void _saxEnclosures (SyndEntry entry) throws SAXException
Index: main/plugin-syndication/src/org/ametys/plugins/syndication/FeedResult.java
===================================================================
--- main/plugin-syndication/src/org/ametys/plugins/syndication/FeedResult.java	(revision 0)
+++ main/plugin-syndication/src/org/ametys/plugins/syndication/FeedResult.java	(revision 0)
@@ -0,0 +1,140 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.syndication;
+
+import java.util.Date;
+
+import com.sun.syndication.feed.synd.SyndFeed;
+
+/**
+ * A feed retrieve result.
+ */
+public class FeedResult
+{
+    
+    /** The status is unknown. */
+    public static final int STATUS_UNKNOWN = 0;
+    
+    /** Status indicating that the feed was retrieved successfully. */
+    public static final int STATUS_OK = 1;
+    
+    /** Status indicating that there was an error retrieving the feed. */
+    public static final int STATUS_ERROR = 2;
+    
+    /** The status. */
+    protected int _status;
+    
+    /** The feed. */
+    protected SyndFeed _feed;
+    
+    /** The message error. */
+    protected String _messageError;
+    
+    /** The creation date. */
+    protected Date _creationDate;
+    
+    /**
+     * Build a FeedResult object, status unknown.
+     */
+    public FeedResult()
+    {
+        this(STATUS_UNKNOWN, null);
+    }
+    
+    /**
+     * Build a FeedResult object.
+     * @param status the status.
+     * @param feed the feed.
+     */
+    public FeedResult(int status, SyndFeed feed)
+    {
+        this._status = status;
+        this._feed = feed;
+    }
+
+    /**
+     * Get the status.
+     * @return the status
+     */
+    public int getStatus()
+    {
+        return _status;
+    }
+
+    /**
+     * Set the status.
+     * @param status the status to set
+     */
+    public void setStatus(int status)
+    {
+        this._status = status;
+    }
+
+    /**
+     * Get the feed.
+     * @return the feed
+     */
+    public SyndFeed getSynFeed()
+    {
+        return _feed;
+    }
+    
+    /**
+     * Get the message error.
+     * @return the message error
+     */
+    public String getMessageError()
+    {
+        return _messageError;
+    }
+    
+    /**
+     * Set the message error.
+     * @param messageError the message error to set
+     */
+    public void setMessageError(String messageError)
+    {
+        this._messageError = messageError;
+    }
+
+    /**
+     * Set the feed.
+     * @param feed the feed to set
+     */
+    public void setResponse(SyndFeed feed)
+    {
+        this._feed = feed;
+    }
+    
+    /**
+     * Get the creation date.
+     * @return the creation date
+     */
+    public Date getCreationDate()
+    {
+        return _creationDate;
+    }
+
+    /**
+     * Set the creation Date.
+     * @param creationDate the creation date to set
+     */
+    public void setCreationDate(Date creationDate)
+    {
+        this._creationDate = creationDate;
+    }
+    
+}
Index: main/plugin-syndication/src/org/ametys/plugins/syndication/FeedCache.java
===================================================================
--- main/plugin-syndication/src/org/ametys/plugins/syndication/FeedCache.java	(revision 0)
+++ main/plugin-syndication/src/org/ametys/plugins/syndication/FeedCache.java	(revision 0)
@@ -0,0 +1,349 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.plugins.syndication;
+
+import java.io.IOException;
+import java.net.HttpURLConnection;
+import java.net.MalformedURLException;
+import java.net.URL;
+import java.util.Calendar;
+import java.util.Collection;
+import java.util.Date;
+import java.util.GregorianCalendar;
+import java.util.concurrent.CountDownLatch;
+import java.util.concurrent.ExecutionException;
+import java.util.concurrent.TimeUnit;
+
+import org.apache.avalon.framework.activity.Initializable;
+import org.apache.avalon.framework.component.Component;
+import org.apache.avalon.framework.context.ContextException;
+import org.apache.avalon.framework.logger.AbstractLogEnabled;
+import org.apache.avalon.framework.logger.Logger;
+import org.apache.avalon.framework.service.ServiceException;
+
+import com.google.common.cache.CacheBuilder;
+import com.google.common.cache.CacheLoader;
+import com.google.common.cache.LoadingCache;
+import com.sun.syndication.feed.synd.SyndFeed;
+import com.sun.syndication.io.FeedException;
+import com.sun.syndication.io.SyndFeedInput;
+import com.sun.syndication.io.XmlReader;
+
+/**
+ * Feed cache, supports preloading multiple feeds in multiple concurrent threads.
+ */
+public class FeedCache extends AbstractLogEnabled implements Component, Initializable
+{
+    /** The component role. */
+    public static final String ROLE = FeedCache.class.getName();
+    
+    /** The user information cache. */
+    protected LoadingCache<String, FeedResult> _cache;
+    
+    @Override
+    public void initialize() throws Exception
+    {
+        FeedCacheLoader loader = new FeedCacheLoader();
+        
+        CacheBuilder<Object, Object> cacheBuilder = CacheBuilder.newBuilder()
+                .expireAfterWrite(24, TimeUnit.HOURS);
+        
+        _cache = cacheBuilder.build(loader);
+    }
+    
+    /**
+     * Pre-load a collection of feeds, one by thread, to avoid getting timeouts sequentially.
+     * @param feeds the feeds to preload.
+     */
+    public void preload(Collection<String> feeds)
+    {
+        if (getLogger().isDebugEnabled())
+        {
+            getLogger().debug("Preloading " + feeds.size() + " feeds...");
+        }
+        
+        long start = System.currentTimeMillis();
+        
+        // Synchronization helper.
+        CountDownLatch doneSignal = new CountDownLatch(feeds.size());
+        
+        for (String feed : feeds)
+        {
+            // Test if the feed is already in the cache.
+            FeedResult result = _cache.getIfPresent(feed);
+            
+            if (result == null)
+            {
+                // The feed is not in the cache: prepare and launch a thread to retrieve it.
+                FeedLoadWorker worker = new FeedLoadWorker(feed, doneSignal);
+                
+                try
+                {
+                    worker.initialize(getLogger());
+                }
+                catch (Exception e)
+                {
+                    // Ignore
+                }
+                
+                new Thread(worker).start();
+            }
+            else
+            {
+                // The feed is already in the cache: count down.
+                doneSignal.countDown();
+            }
+        }
+        
+        try
+        {
+            // Wait for all the URLs to be loaded (i.e. all the threads to end).
+            doneSignal.await();
+            
+            if (getLogger().isDebugEnabled())
+            {
+                long end = System.currentTimeMillis();
+                getLogger().debug("Feed preloading ended in " + (end - start) + " millis.");
+            }
+        }
+        catch (InterruptedException e)
+        {
+            // Ignore, let the threads finish or die.
+        }
+    }
+    
+    /**
+     * Get a feed not from the cache.
+     * @param feedUrl the feed.
+     * @return the feed result.
+     * @throws IOException 
+     */
+    public FeedResult getFeedNoCache(String feedUrl) throws IOException
+    {
+        return loadFeed(feedUrl);
+    }
+    
+    /**
+     * Get a feed.
+     * @param feedUrl the feed.
+     * @param lifeTime
+     * @return the feed response.
+     */
+    public FeedResult getFeed(String feedUrl, int lifeTime)
+    {
+        try
+        {
+            FeedResult feedResult = _cache.get(feedUrl);
+            Date dateFeed = feedResult.getCreationDate();
+            
+            GregorianCalendar calendar = new GregorianCalendar();
+            calendar.setTime(dateFeed);
+            
+            calendar.add(Calendar.MINUTE, lifeTime);
+            
+            Date dateToday = new Date();
+            if (dateToday.after(calendar.getTime()))
+            {
+                _cache.invalidate(feedUrl);
+                return _cache.get(feedUrl);
+            }
+            else
+            {
+                return feedResult;
+            }
+        }
+        catch (ExecutionException e)
+        {
+            getLogger().error(e.getLocalizedMessage());
+        }
+        
+        return null;
+    }
+    
+    /**
+     * Retrieve a feed's content to store it into the cache.
+     * @param feedUrl the feed to load.
+     * @return the feed content.
+     * @throws IOException 
+     */
+    protected FeedResult loadFeed(String feedUrl) throws IOException
+    {
+        FeedResult result = new FeedResult();
+        
+        Date todayDate = new Date();
+        result.setCreationDate(todayDate);
+        
+        SyndFeedInput input = new SyndFeedInput();
+        SyndFeed synFeed = null;
+        
+        try
+        {
+            URL feedSource = new URL(feedUrl);
+            HttpURLConnection connection = (HttpURLConnection) feedSource.openConnection();
+            connection.setRequestProperty("User-Agent", "Ametys/3 (compatible; MSIE 6.0)");
+
+            int responseCode = connection.getResponseCode();
+            if (responseCode != HttpURLConnection.HTTP_OK)
+            {
+                result.setStatus(FeedResult.STATUS_ERROR);
+                result.setMessageError("Unable to join the RSS feed : " + feedUrl + ". HTTP response code is " + responseCode + ".");
+                getLogger().error("Unable to join the RSS feed : " + feedUrl + ". HTTP response code is " + responseCode + ".");
+                return result;
+            }
+
+            synFeed = input.build(new XmlReader(connection));
+            result.setStatus(FeedResult.STATUS_OK);
+            result.setResponse(synFeed);
+        }
+        catch (FeedException e)
+        {
+            result.setStatus(FeedResult.STATUS_ERROR);
+            result.setMessageError(e.getLocalizedMessage());
+            getLogger().error("Unable to read the RSS feed to the url : " + feedUrl);
+        }
+        catch (MalformedURLException e)
+        {
+            result.setStatus(FeedResult.STATUS_ERROR);
+            result.setMessageError(e.getLocalizedMessage());
+            getLogger().error("Unable to read the RSS feed to the url : " + feedUrl + ". Malformed url");
+        }
+        catch (IOException e)
+        {
+            result.setStatus(FeedResult.STATUS_ERROR);
+            result.setMessageError(e.getLocalizedMessage());
+            getLogger().error("Unable to read the RSS feed to the url : " + feedUrl);
+        }
+        catch (Exception e)
+        {
+            result.setStatus(FeedResult.STATUS_ERROR);
+            result.setMessageError(e.getLocalizedMessage());
+            getLogger().error("Unable to read the RSS feed to the url : " + feedUrl);
+        }
+        
+        return result;
+    }
+    
+    /**
+     * The feed cache loader, delegates the loading to the component's loadFeed method (to be easily overridable).
+     */
+    protected class FeedCacheLoader extends CacheLoader<String, FeedResult>
+    {
+        @Override
+        public FeedResult load(String feedUrl) throws Exception
+        {
+            return loadFeed(feedUrl);
+        }
+    }
+    
+    /**
+     * Runnable loading an URL into the cache.
+     */
+    protected class FeedLoadWorker implements Runnable
+    {
+        
+        /** The logger. */
+        protected Logger _logger;
+        
+        /** Is the engine initialized ? */
+        protected boolean _initialized;
+        
+        private final CountDownLatch _endSignal;
+        
+        private final String _feedUrl;
+        
+        /**
+         * Build a worker loading a specific feed.
+         * @param feedUrl the feed to load.
+         * @param endSignal the signal when done.
+         */
+        FeedLoadWorker(String feedUrl, CountDownLatch endSignal)
+        {
+            this._feedUrl = feedUrl;
+            this._endSignal = endSignal;
+        }
+        
+        /**
+         * Initialize the feed loader.
+         * @param logger the logger.
+         * @throws ContextException
+         * @throws ServiceException
+         */
+        public void initialize(Logger logger) throws ContextException, ServiceException
+        {
+            _logger = logger;
+            _initialized = true;
+        }
+                
+        public void run()
+        {
+            try
+            {
+                if (_logger.isDebugEnabled())
+                {
+                    _logger.debug("Preparing to load the URL '" + _feedUrl + "'");
+                }
+                
+                long start = System.currentTimeMillis();
+                
+                _checkInitialization();
+                
+                // Load the feed and signal that it's done.
+                _cache.get(_feedUrl);
+                
+                if (_logger.isDebugEnabled())
+                {
+                    long end = System.currentTimeMillis();
+                    _logger.debug("URL '" + _feedUrl + "' was loaded successfully in " + (end - start) + " millis.");
+                }
+            }
+            catch (Exception e)
+            {
+                _logger.error("An error occurred loading the URL '" + _feedUrl + "'", e);
+            }
+            finally
+            {
+                // Signal that the worker has finished. 
+                _endSignal.countDown();
+                
+                // Dispose of the resources.
+                _dispose();
+            }
+        }
+        
+        /**
+         * Check the initialization and throw an exception if not initialized.
+         */
+        protected void _checkInitialization()
+        {
+            if (!_initialized)
+            {
+                String message = "Le composant de synchronisation doit être initialisé avant d'être lancé."; //TODO
+                _logger.error(message);
+                throw new IllegalStateException(message);
+            }
+        }
+        
+        /**
+         * Dispose of the resources and looked-up components.
+         */
+        protected void _dispose()
+        {
+            _initialized = false;
+        }
+        
+    }
+
+}
